/**
 * BBPhBufTest.java
 * Created: Feb 19, 2006
 */
package tests.jmarkov;

import jmarkov.basic.State;
import jmarkov.basic.exceptions.NotUnichainException;
import jphase.ContPhaseVar;
import jphase.DenseContPhaseVar;
import junit.framework.TestCase;
import examples.jmarkov.BBPhBuf;
import examples.jmarkov.BucketBuffers;

/**
 * @author Germn Riao. Universidad de los Andes. (C) 2006
 */
public class BBPhBufTest extends TestCase {

    /**
     * @param args
     */
    public static void main(String[] args) {
        junit.swingui.TestRunner.run(BBPhBufTest.class);
    }

    /**
     * 
     */
    public BBPhBufTest() {
        super();
    }

    BBPhBuf buildModel() {
        BBPhBuf bbp = null;
        int N = 2;
        int M = 3;
        int[] bufferCaps = { 1, 2 };
        ContPhaseVar v = DenseContPhaseVar.Erlang(1.0, 2);
        ContPhaseVar v2 = DenseContPhaseVar.expo(1.0);
        ContPhaseVar[] machineTimes = { v, v, v2 };
        double[][] velocities = { { 1, 1, 2 }, { 2, 3, 3 }, };
        bbp = null;
        System.gc();
        bbp = new BBPhBuf(N, M, machineTimes, velocities, bufferCaps);
        bbp.setDebugLevel(0);
        bbp.setMaxStates(40000);
        return bbp;
    }
//
//    /**
//     * Test method for 'jmarkov.SimpleMarkovProcess.getMOPsAvg()'
//     * @throws NotUnichainException
//     */
//    public void testGetMOPsAvg() throws NotUnichainException {
//        BBPhBuf bbp = buildModel();
//        double mops[] = bbp.getMOPsAvg();
//        double expMops[] = new double[] { 0.621037632463589,
//                0.027008114263533282, 0.0, 0.34924196262267726,
//                0.43083779229796376, 0.21992025697012577, 0.6480457467271221,
//                1.0000000118907666, 1.6480457586178887, 0.9702795950862662,
//                0.4578459065614971, 0.21992025697012577, 0.0,
//                0.13748234355497274, 0.0, 0.3519542651636444, 0.0 };
//        bbp = null;
//        System.gc();
//        assertArrayEquals("Mops are different.", expMops, mops, 1e-5);
//    }
//
//    /**
//     * @throws NotUnichainException
//     */
//    /*
//     * Test method for 'jmarkov.SimpleMarkovProcess.getEventsRates()'
//     */
//    public void testGetEventsRates() throws NotUnichainException {
//        BBPhBuf bbp = buildModel();
//        double rates[] = bbp.getEventsRates();
//        double expRates[] = new double[] { 0.43259279822822333,
//                0.21545294849889904, 0.8869287143089063, 1.7638293587407163 };
//        bbp = null;
//        System.gc();
//
//        assertArrayEquals("Event Rates are different", expRates, rates, 1e-5);
//    }
//
//    /**
//     * @throws NotUnichainException
//     */
//    public void testThruputRate() throws NotUnichainException {
//        BBPhBuf bbp = buildModel();
//        double val = bbp.getResetRate();
//        bbp = null;
//        System.gc();
//
//        assertEquals("Error in Throughput ", 0.6597607709103771, val, 1e-5);
//    }
//
//    /**
//     * Test results against the no buffers case
//     * @throws NotUnichainException
//     */
//    public void testNoBuffers() throws NotUnichainException {
//        int N = 2;
//        int M = 2;
//        DenseContPhaseVar v = DenseContPhaseVar.Erlang(1.0, 2);
//        DenseContPhaseVar[] machineTimes = { v, v };
//        double[][] vels = { { 1, 1 }, { 2, 3 }, };
//        int buffs[] = { 0 };
//        BBPhBuf bb_model = new BBPhBuf(N, M, machineTimes, vels, buffs);
//        bb_model.setDebugLevel(0);
//
//        double mops[] = bb_model.getMOPsAvg();
//        double expMops[] = new double[] { 0.43346007631073086, 0.0,
//                0.5133079868373442, 0.4866920150588287, 0.43346007631073086,
//                1.000000001896173, 1.4334600782069038, 0.946768063148075,
//                0.4866920150588287, 0.0, 0.0, 0.5665399255854421, 0.0 };
//
//        assertArrayEquals("Mops are different.", expMops, mops, 1e-5);
//        double rates[] = bb_model.getEventsRates();
//        double expRates[] = new double[] { 0.31939163503624357,
//                0.11406844127448725, 1.1406844125743791, 1.3460076062767956 };
//        assertArrayEquals("Event Rates are different", expRates, rates, 1e-5);
//        double val = bb_model.getResetRate();
//        assertEquals("Error in Throughput ", 0.7300380220716589, val, 1e-5);
//
//    }
//
//    // test for expo servers
//
//    /**
//     * test for identical expo servers and machines
//     * @throws NotUnichainException
//     */
//    public void testEqualExpo() throws NotUnichainException {
//        double mu = 1.0;// service rate
//        for (int M = 1; M <= 7; M += 2) {
//            for (int N = 1; N <= 3; N += 2) {// Operators
//                ContPhaseVar procTimes[] = new ContPhaseVar[M];
//                double vels[][] = new double[N][M];
//                for (int n = 0; n < N; n++) {
//                    for (int m = 0; m < M; m++) {
//                        vels[n][m] = 1.0;
//                    }
//                }
//                ContPhaseVar v = DenseContPhaseVar.expo(mu);
//                for (int m = 0; m < M; m++)
//                    procTimes[m] = v;
//                int buffs[] = new int[M - 1];
//                double expTh = N * mu / (M + N - 1);
//                BBPhBuf bbp_model = new BBPhBuf(N, M, procTimes, vels, buffs);
//                bbp_model.setDebugLevel(0);
//                bbp_model.setMaxStates(2000);
//                double val = bbp_model.getResetRate();
//                bbp_model.debug(1, "Test equal machines and workers .M=" + M
//                        + ", N= " + N + ", States = "
//                        + bbp_model.getNumStates());
//                assertEquals("Error in Thruput ", expTh, val, 1e-10);
//                bbp_model = null;
//                System.gc();
//            }
//        }
//    }
//
//    /**
//     * Compares with Expo BB system with different velocities.
//     * @throws NotUnichainException
//     */
//    public void testExpo() throws NotUnichainException {
//        for (int M = 1; M <= 7; M += 2) {// Machines
//            for (int N = 1; N <= 3; N += 2) {// Operators
//                ContPhaseVar times[] = new ContPhaseVar[M];
//                double vels[][] = new double[N][M];
//                for (int n = 0; n < N; n++) {
//                    for (int m = 0; m < M; m++) {
//                        vels[n][m] = (m + 1.0) / (n + 1.0);
//                    }
//                }
//                ContPhaseVar v = DenseContPhaseVar.expo(1.0);
//                for (int m = 0; m < M; m++)
//                    times[m] = v;
//                int buffs[] = new int[M - 1];
//                BBPhBuf bbp_model = null;
//                System.gc();
//                bbp_model = new BBPhBuf(N, M, times, vels, buffs);
//                bbp_model.setDebugLevel(0);
//                bbp_model.generate();
//                bbp_model.setDebugLevel(0);
//                bbp_model.setMaxStates(2000);
//
//                BucketBrigades bb = new BucketBrigades(N, M, vels);
//                bb.setDebugLevel(0);
//                bb.setMaxStates(2000);
//                bb.generate();
//                bb.setDebugLevel(0);
//                double expTh = bb.getEventRate(M - 1);
//
//                double val = bbp_model.getResetRate();
//                bbp_model.debug(1, "Test expo. M=" + M + ", N= " + N
//                        + ", States = " + bbp_model.getNumStates() + ". Th = "
//                        + expTh);
//                assertEquals("Error in Thruput for N=" + N + ", M=" + M, expTh,
//                        val, 1e-5);
//                bbp_model = null;
//                System.gc();
//            }
//        }
//    }
//
//    /**
//     * Compares the BB system with a CONWIP system results. This
//     * requires identical exponential workers (but stations may
//     * differ).
//     * @throws NotUnichainException
//     */
//    public void testExpoIdenticalWorkers() throws NotUnichainException {
//        BBPhBuf bbp = null;
//        for (int M = 1; M <= 7; M += 2) {
//            for (int N = 1; N <= 5; N += 2) {// Operators
//                ContPhaseVar procTimes[] = new ContPhaseVar[M];
//                int buffs[] = new int[M - 1];
//
//                double mu[] = new double[M];// basic service rate
//                double vels[][] = new double[N][M];
//                for (int n = 0; n < N; n++) {
//                    for (int m = 0; m < M; m++) {
//                        mu[m] = m + 1;
//                        // generates different rates:
//                        vels[n][m] = 1.0 * mu[m];
//                    }
//                }
//                ContPhaseVar v = DenseContPhaseVar.expo(1.0);
//                for (int m = 0; m < M; m++)
//                    procTimes[m] = v;
//                bbp = new BBPhBuf(N, M, procTimes, vels, buffs);
//                bbp.setDebugLevel(0);
//                bbp.setMaxStates(2000);
//                bbp.generate();
//                bbp.setDebugLevel(0);
//                double val = bbp.getResetRate();
//
//                // Jackson jacky = new Jackson(N, M, mu);
//                // jacky.setDebugLevel(0);
//                // double expTh = jacky.getEventRate(M - 1);
//
//                double lambdas[] = getMVAthruput(N, M, mu);
//                double expTh = lambdas[M - 1];
//
//                bbp.debug(1, "Test Iden Wks. M=" + M + ", N= " + N
//                        + ", States = " + bbp.getNumStates());
//                if (Math.abs(expTh - val) > 1e-5) {
//                    bbp.reset();
//                    bbp.setDebugLevel(5);
//                    bbp.generate();
//                }
//                assertEquals("Error in Thruput for N=" + N + ", M=" + M, expTh,
//                        val, 1e-5);
//            }
//        }
//    }

    /**
     * Compares with Expo BB system with different velocities and
     * buffer sizes.
     * @throws NotUnichainException
     */
    @SuppressWarnings("unchecked")
    public void testExpoWithBuffers() throws NotUnichainException {
        for (int N = 1; N <= 3; N += 2) {// Operators
            for (int M = 1; M <= 3; M += 2) {// Machines
                for (int B = 1; B <= 3; B++) {// Buffers
                    ContPhaseVar times[] = new ContPhaseVar[M];
                    double vels[][] = new double[N][M];
                    for (int n = 0; n < N; n++) {
                        for (int m = 0; m < M; m++) {
                            vels[n][m] = 10 * (n + 1.0) + (m + 1.0);
                        }
                    }
                    ContPhaseVar v = DenseContPhaseVar.expo(1.0);
                    int buffs[] = new int[M - 1];
                    int BBbuffs[] = new int[M];
                    for (int m = 0; m < M; m++) {
                        times[m] = v;
                        BBbuffs[m] = B;
                        if (m < M - 1)
                            buffs[m] = B;
                    }
                    BBPhBuf bbp = null;
                    System.gc();
                    bbp = new BBPhBuf(N, M, times, vels, buffs);
                    bbp.setMaxStates(5000);
                    bbp.setDebugLevel(0);
                    bbp.generate();
                    bbp.setDebugLevel(0);

                    BucketBuffers bb = new BucketBuffers(vels, BBbuffs);
                    bb.setDebugLevel(0);
                    bb.setMaxStates(5000);
                    bb.generate();
                    bb.setDebugLevel(0);
                    double expTh = bb.getEventRate(M - 1);

                    double val = bbp.getResetRate();
                    bbp.debug(0, "Test expo. M=" + M + ", N=" + N + ", B="
                            + B + ", States = " + bbp.getNumStates()
                            + ". Th = " + expTh);
                    if (Math.abs(expTh - val) > 1e-5) {
                        State[] sttBB = bb.getStates().toStateArray();
                        State[] sttBBP = bbp.getStates().toStateArray();
                        int n1 = sttBB.length, n2 = sttBBP.length;
                        int n = Math.max(n1, n2);
                        System.out.println("*********** Test expo. M = " + M
                                + ", N = " + N + ", B = " + B);
                        for (int i = 0; i < n; i++) {
                            System.out.println("States  " + i + ": "
                                    + ((i < n1) ? sttBB[i] : "     ") + " and "
                                    + ((i < n2) ? sttBBP[i] : "      "));
                        }
                        bbp.reset();
                        bbp.setDebugLevel(4);
                        bbp.generate();
                        bb.reset();
                        bb.setDebugLevel(4);
                        bb.generate();
                    }
                    assertEquals("Error in Thruput for N=" + N + ", M=" + M
                            + ", B =" + B, expTh, val, 1e-5);
                    bbp = null;
                    System.gc();
                }
            }
        }
    }

}
