/*
 * Copyright (C) 2003 Bjrn-Ove Heimsund
 * 
 * This file is part of JMP.
 * 
 * JMP is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * JMP is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with JMP; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jmp;

/**
 * Matrix consisting of sub-matrices
 */
public interface BlockAccessMatrix extends Matrix {

	/**
	 * Returns number of blocks
	 */
	int numBlocks();

	/**
	 * Returns the matrix in block i
	 */
	Matrix getBlock(int i);

	/**
	 * Returns the row-indices of block i
	 */
	int[] getBlockRowIndices(int i);

	/**
	 * Returns the column-indices of block i
	 */
	int[] getBlockColumnIndices(int i);

	/**
	 * Sets block i to the given matrix, with row and column indices
	 */
	void setBlock(int i, int[] row, int[] column, Matrix A);

}
