/*
 * Copyright (C) 2003 Bjrn-Ove Heimsund
 * 
 * This file is part of JMP.
 * 
 * JMP is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * JMP is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with JMP; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jmp;

/**
 * Sparse matrix with fast access to the whole structure, with row-major
 * indices.
 */
public interface SparseRowColumnAccessMatrix extends Sparse, Matrix {

	/**
	 * Returns a sparse representation of the matrix (backed by the matrix)
	 */
	IntIntDoubleVectorTriple getMatrix();

	/**
	 * Sets the whole matrix. The indices must be sorted.
	 */
	void setMatrix(IntIntDoubleVectorTriple x);

}
