/*
 * Copyright (C) 2003 Bjrn-Ove Heimsund
 * 
 * This file is part of JMP.
 * 
 * JMP is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * JMP is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with JMP; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jmp.io;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

import jmp.Matrix;
import jmp.Vector;

/**
 * Writes matrices and vectors using object serialization
 */
public class SerializedWriter
	extends ObjectOutputStream
	implements MatrixVectorWriter {

	/**
	 * Constructor for SerializedWriter.
	 */
	public SerializedWriter(OutputStream out) throws IOException {
		super(out);
	}

	/**
	 * @see jmp.io.MatrixVectorWriter#writeMatrix(jmp.Matrix)
	 */
	public void writeMatrix(Matrix A) throws IOException {
		writeObject(A);
		flush();
	}

	/**
	 * @see jmp.io.MatrixVectorWriter#writeVector(jmp.Vector)
	 */
	public void writeVector(Vector x) throws IOException {
		writeObject(x);
		flush();
	}

}
