/*
 * Copyright (C) 2003 Bjrn-Ove Heimsund
 * 
 * This file is part of JMP.
 * 
 * JMP is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * JMP is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with JMP; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jmp.iter.eig;

import java.io.OutputStream;
import java.io.PrintWriter;

import jmp.Vector;

/**
 * Outputs residual information to a stream
 */
public class OutputEigenvalueIterationMonitor
	implements EigenvalueIterationMonitor {

	private PrintWriter out;

	/**
	 * Constructor for OutputEigenvalueIterationMonitor. Uses System.err as
	 * default output.
	 */
	public OutputEigenvalueIterationMonitor() {
		out = new PrintWriter(System.err);
	}

	/**
	 * Sets the output stream to use
	 */
	public void setOutputStream(OutputStream out) {
		this.out = new PrintWriter(out);
	}

	/**
	 * @see jmp.iter.eig.EigenvalueIterationMonitor#monitor(double[], double[], jmp.Vector[], int)
	 */
	public void monitor(double[] r, double[] eig, Vector[] x, int i) {
		monitor(r, i);
	}

	/**
	 * @see jmp.iter.eig.EigenvalueIterationMonitor#monitor(double[], double[], int)
	 */
	public void monitor(double[] r, double[] eig, int i) {
		monitor(r, i);
	}

	/**
	 * @see jmp.iter.eig.EigenvalueIterationMonitor#monitor(double[], int)
	 */
	public void monitor(double[] r, int i) {
		out.print(i + "\t");
		for (int j = 0; j < r.length; ++j)
			out.print(r[j] + "\t");
		out.println();
	}

}
