/*
 * Copyright (C) 2003 Bjrn-Ove Heimsund
 * 
 * This file is part of JMP.
 * 
 * JMP is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * JMP is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with JMP; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jmp.iter.linear;

import java.io.OutputStream;
import java.io.PrintWriter;

import jmp.Vector;

/**
 * Outputs iteration information to an output stream.
 */
public class OutputLinearIterationMonitor implements LinearIterationMonitor {

	/**
	 * Platform-dependent output
	 */
	private PrintWriter out;

	/**
	 * Constructor for OutputLinearIterationMonitor
	 * @param out Writes iteration count and current residual here
	 */
	public OutputLinearIterationMonitor(OutputStream out) {
		this.out = new PrintWriter(out, true);
	}

	/**
	 * Constructor for OutputLinearIterationMonitor, using System.err.
	 */
	public OutputLinearIterationMonitor() {
		this(System.err);
	}

	/**
	 * @see jmp.iter.linear.LinearIterationMonitor#monitor(double, int)
	 */
	public void monitor(double r, int i) {
		out.println(i + " " + r);
	}

	/**
	 * @see jmp.iter.linear.LinearIterationMonitor#monitor(double, jmp.Vector, int)
	 */
	public void monitor(double r, Vector x, int i) {
		monitor(r,i);
	}

}
