/*
 * Copyright (C) 2003-2005 Bjrn-Ove Heimsund
 * 
 * This file is part of MTJ.
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation; either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package no.uib.cipr.matrix.sparse.test;

import no.uib.cipr.matrix.sparse.CompRowMatrix;
import no.uib.cipr.matrix.test.Utilities;

/**
 * Test of CompRowMatrix
 */
public class CompRowMatrixTest extends SparseStructImmutableMatrixTest {

    public CompRowMatrixTest(String arg0) {
        super(arg0);
    }

    @Override
    protected void setup() throws Exception {
        int n = Utilities.getInt(max);
        int m = Utilities.getInt(max);
        int b = Utilities.getInt(Math.min(bmax, m));
        int[][] nz = Utilities.getRowPattern(n, m, b);
        A = new CompRowMatrix(n, m, nz);
        Ad = Utilities.rowPopulate(A, nz);
    }

}
